import { Construct } from 'constructs';
import { TerraformResource } from 'cdktf';
import { TerraformMetaArguments } from 'cdktf';
/**
 *
 */
export interface NetworkConfig extends TerraformMetaArguments {
    /**
     *
     */
    readonly attachable?: boolean;
    /**
     *
     */
    readonly checkDuplicate?: boolean;
    /**
     *
     */
    readonly driver?: string;
    /**
     *
     */
    readonly ingress?: boolean;
    /**
     *
     */
    readonly internal?: boolean;
    /**
     *
     */
    readonly ipamDriver?: string;
    /**
     *
     */
    readonly ipv6?: boolean;
    /**
     *
     */
    readonly name: string;
    /**
     *
     */
    readonly options?: {
        [key: string]: string;
    };
    /**
     * ipam_config block.
     */
    readonly ipamConfig?: NetworkIpamConfig[];
    /**
     * labels block.
     */
    readonly labels?: NetworkLabels[];
}
/**
 *
 */
export interface NetworkIpamConfig {
    /**
     *
     */
    readonly auxAddress?: {
        [key: string]: string;
    };
    /**
     *
     */
    readonly gateway?: string;
    /**
     *
     */
    readonly ipRange?: string;
    /**
     *
     */
    readonly subnet?: string;
}
/**
 *
 */
export interface NetworkLabels {
    /**
     * Name of the label.
     */
    readonly label: string;
    /**
     * Value of the label.
     */
    readonly value: string;
}
/**
 *
 */
export declare class Network extends TerraformResource {
    /**
     *
     */
    constructor(scope: Construct, id: string, config: NetworkConfig);
    private _attachable?;
    /**
     *
     */
    get attachable(): boolean;
    /**
     *
     */
    set attachable(value: boolean);
    /**
     *
     */
    resetAttachable(): void;
    /**
     *
     */
    get attachableInput(): boolean | undefined;
    private _checkDuplicate?;
    /**
     *
     */
    get checkDuplicate(): boolean;
    /**
     *
     */
    set checkDuplicate(value: boolean);
    /**
     *
     */
    resetCheckDuplicate(): void;
    /**
     *
     */
    get checkDuplicateInput(): boolean | undefined;
    private _driver?;
    /**
     *
     */
    get driver(): string;
    /**
     *
     */
    set driver(value: string);
    /**
     *
     */
    resetDriver(): void;
    /**
     *
     */
    get driverInput(): string | undefined;
    /**
     *
     */
    get id(): string;
    private _ingress?;
    /**
     *
     */
    get ingress(): boolean;
    /**
     *
     */
    set ingress(value: boolean);
    /**
     *
     */
    resetIngress(): void;
    /**
     *
     */
    get ingressInput(): boolean | undefined;
    private _internal?;
    /**
     *
     */
    get internal(): boolean;
    /**
     *
     */
    set internal(value: boolean);
    /**
     *
     */
    resetInternal(): void;
    /**
     *
     */
    get internalInput(): boolean | undefined;
    private _ipamDriver?;
    /**
     *
     */
    get ipamDriver(): string;
    /**
     *
     */
    set ipamDriver(value: string);
    /**
     *
     */
    resetIpamDriver(): void;
    /**
     *
     */
    get ipamDriverInput(): string | undefined;
    private _ipv6?;
    /**
     *
     */
    get ipv6(): boolean;
    /**
     *
     */
    set ipv6(value: boolean);
    /**
     *
     */
    resetIpv6(): void;
    /**
     *
     */
    get ipv6Input(): boolean | undefined;
    private _name;
    /**
     *
     */
    get name(): string;
    /**
     *
     */
    set name(value: string);
    /**
     *
     */
    get nameInput(): string;
    private _options?;
    /**
     *
     */
    get options(): {
        [key: string]: string;
    };
    /**
     *
     */
    set options(value: {
        [key: string]: string;
    });
    /**
     *
     */
    resetOptions(): void;
    /**
     *
     */
    get optionsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     *
     */
    get scope(): string;
    private _ipamConfig?;
    /**
     *
     */
    get ipamConfig(): NetworkIpamConfig[];
    /**
     *
     */
    set ipamConfig(value: NetworkIpamConfig[]);
    /**
     *
     */
    resetIpamConfig(): void;
    /**
     *
     */
    get ipamConfigInput(): NetworkIpamConfig[] | undefined;
    private _labels?;
    /**
     *
     */
    get labels(): NetworkLabels[];
    /**
     *
     */
    set labels(value: NetworkLabels[]);
    /**
     *
     */
    resetLabels(): void;
    /**
     *
     */
    get labelsInput(): NetworkLabels[] | undefined;
    /**
     *
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
